#include <stdio.h>

struct prenota {
       long matricola;
       char programma[30];
       int ora;
       int aula;
       };

void inserisci(struct prenota *V,int *pn)
{
     struct prenota p;
     
     if(*pn<30) /* vettore non e' pieno*/
      { /* lettura prenotazione*/
        printf("Matricola: ");
        scanf("%ld",&p.matricola);
        printf("Programma: ");
        scanf("%s",p.programma);
        printf("Ora (1..5):");
        scanf("%d",&p.ora);
        printf("Aula: ");
        scanf("%d",&p.aula);
        /*inserimento*/
        V[*pn]=p;
        (*pn)++;
      }
      else  printf("Vettore pieno\n");
        
 }
 
void visualizza (struct prenota *V, int n)
{
      int ora,i;
      
      printf("Ora: ");
      scanf("%d",&ora);
      for(i=0;i<n;i++)
         if(V[i].ora==ora)
            {printf("Matricola: %ld\n",V[i].matricola);
             printf("Programma: %s\n",V[i].programma);
             printf("Aula: %d\n",V[i].aula);
            }
}

void cambia (struct prenota *V, int n  )
{
 int aula,k;
 long matricola;
 int ora;
 
 printf("Matricola: ");
 scanf("%ld",&matricola);
 printf("Aula: ");
 scanf("%d",&aula);
 
 /* ricerca*/
 for(k=0;k<n;k++)
   if(V[k].matricola==matricola && V[k].aula==aula)
      { /* trovato */
         /* richiesta della nuova ora*/
        printf("Nuova ora\n");
        scanf("%d",&ora);
        V[k].ora=ora;
        return;
      }
 
 printf("Elemento non trovato\n");
 /* 
   for(k=0;k<n;k++)
     if(V[k].matricola==matricola && V[k].aula==aula)
         break;
   
   if(k<n)  
        { printf("Nuova ora\n");
           scanf("%d",&ora);
           V[k].ora=ora;
        }
   else printf("Elemento non trovato\n");
   */     
            
}
      
void salva (struct prenota *V, int n)
{
     FILE *pf;
     int ora,i;
     
     printf("Ora: ");
     scanf("%d",&ora);
     
     pf=fopen("Prenota.dat","wb");
     if(pf) /* oppure if(pf!=NULL) */ 
      {
        for(i=0;i<n;i++)
          if(V[i].ora==ora)
             fwrite(&V[i],sizeof(struct prenota),1,pf);
        fclose(pf);
      }
      else printf("File non aperto");
}

void inizializza(struct prenota *V, int *pn)
{
   struct prenota p;
   int i;
   FILE *pf;
   
   
   i=0;
   pf=fopen("Prenota.dat","rb");
   if(pf)
    {
      while(i<30 && fread(&p,sizeof(struct prenota),1,pf)>0)
       {V[i]=p;
        i++;
       } 
      fclose(pf);
    }
   else printf("Errorein lettura\n");
   *pn=i;
      
}    

main() {
 struct prenota P[30];
 int numero;
 int opzione;
 
 
 inizializza(P,&numero);
 
 do{
    printf("Scegli tra le seguenti opzioni\n");
    printf("1) Inserimento\n2) Visualizzazione\n");
    printf("3) Cambio ora\n4) Salvataggio su file\n");
    printf("0) Fine esecuzione\n");
    scanf("%d",&opzione);
    switch(opzione) {
    case 1: inserisci(P,&numero);
            break;
    case 2: visualizza(P,numero);
            break;
    case 3: cambia(P,numero);
            break;
    case 4: salva(P,numero);
            break;
    default:;
    }
  } while( opzione!=0);
}
