#include <stdio.h>

struct prod {
       char nome[20];
       int codice;
       char scadenza[12];
       float prezzo;
       };
       
void inserisci( struct prod *V, int *pn)
{
     struct prod p;
     
     if(*pn<30) /* Vettore non pieno */
      {  /* lettura prodotto */
         printf("Nome: ");
         scanf("%s",p.nome);
         printf("Codice prodotto: ");
         scanf("%d",&p.codice);
         printf("Data scadenza (gg/mm/aaaa): ");
         scanf("%s",p.scadenza);
         printf("Prezzo: ");
         scanf("%f",&p.prezzo);
         
         /* inserimento */
         V[*pn]=p;
         (*pn)++;
      }
      else printf("Vettore pieno\n");
}

void elimina (struct prod *V, int *pn)
{
     int codice;
     int p,i;
     
     printf("Codice prodotto: ");
     scanf("%d",&codice);
     
     /* Ricerca*/
     for(p=0;p<*pn;p++)
      if(V[p].codice==codice)
         break;
         
     if( p< *pn) /* Trovato in posizione p*/
      {   
          /* Visualizzazione*/
          printf("Nome: %s\n",V[p].nome);
          printf("Data scadenza: %s\n",V[p].scadenza);
          printf("Prezzo: %f\n",V[p].prezzo);
      
          /* Eliminazione */
          for(i=p;i<*pn-1;i++)
            V[i]=V[i+1];
          (*pn)--;
      }
      else printf("Prodotto non trovato\n");
}

void lettura(struct prod *V, int *pn)
{  
    FILE *pf;
    struct prod p;
    int i;
    
    i=0;
    pf=fopen("prodotti.dat","rb");
    if(pf)  /* oppure if(pf!=NULL)  */
      { while (i<30 && fread(&p,sizeof(struct prod),1,pf)> 0)
         { 
              V[i]=p;
              i++;
         }
         fclose(pf);
      }
    else printf("ERRORE IN LETTURA\n");
    *pn=i;
}

void salva(struct prod *V, int n)
{
     FILE *pf;
     int i;
     
     pf=fopen("prodotti.dat","wb");
     if(pf)
       {  for(i=0;i<n;i++)
            if(V[i].prezzo>2)
               fwrite(&V[i],sizeof(struct prod),1,pf);
          fclose(pf);
       }
      else printf("FILE NON APERTO\n");
}      

main() {
       
  struct prod A[30];
  int n,scelta;
  
  n=0;
  do {
      printf("Scegli\n");
      printf("1) Lettura da file\n2) Inserimento\n");
      printf("3) Elimina\n4) Salva\n0) Fine\n");
      scanf("%d",&scelta);
      switch(scelta) {
         case 1: lettura(A,&n);
                 break;
         case 2: inserisci(A,&n);
                 break;
         case 3: elimina(A,&n);
                 break;
         case 4: salva(A,n);
                 break;
         default:;
      }
     } while(scelta !=0);
}       
     
                         
